#
#
# $Id: gtkboards.rb,v 1.10 2005/12/20 14:37:10 ys Exp $
#
#

class BoardSelector < GtkExt::BBSMenuTree

	class NodeData
		attr :uri

		def initialize(uri)
			@uri = uri
		end
	end

	def initialize
		super("Board Tree")
		@ctree.set_headers_visible(false)
		@row_data = {}
		insert
	end

	def update
		BBSMenu.get
		#child.freeze
		@ctreein.clear
		#child.thaw
		insert
	end

	def insert
		#child.freeze
		root = @ctreein.append(nil)
		root.set_value(0, "The 2ch Boards")
		#root = child.insert_node(nil, nil, ["The 2ch Boards"], 1,
		#	nil, nil, nil, nil, false, true)
		nodes = BBSMenu.parse
		nodes.each {|info|
			if info[1] == 'C-'
				@semiroot = @ctreein.append(root)
				@semiroot.set_value(0, Uconv.euctou8((info[0])))
				#@semiRoot = child.insert_node(root, nil, [info[0]], 1,
				#	nil, nil, nil, nil, false, false)
			else
				node = @ctreein.append(@semiroot)
				node.set_value(0, Uconv.euctou8((info[0])))
				#node = child.insert_node(@semiRoot, nil, [info[0]], 1,
				#	nil, nil, nil, nil, true, false)
				set_row_data(node, NodeData.new(info[1]))
			end
		}
		@ctree.expand_row(root.path, false)
		#child.thaw

		#insert_etc
	end
	private :insert

	def set_row_data(node, obj)
		@row_data[node.to_s]= obj
	end

	def get_row_data(node)
		@row_data[node.to_s]
	end

	def insert_etc
		#child.freeze
		root = @ctreein.append(nil)
		root.set_value(0, "Extra Boards")
		nodes = CFG::ETC.sites
		nodes.each {|info|
			node = @ctreein.append(root)
			node.set_value(0, Uconv.euctou8((info[0])))
			set_row_data(node, NodeData.new(info[1]))
		}
		@ctree.expand_row(root.path, false)
		#child.thaw
	end
	private :insert_etc

	def std?(board)
		BBSMenu.stdboard?(board)
	end
end
